# ชื่อโครงงาน : Tetris Upgrade
โครงงานนี้เป็นส่วนหนึ่งของรายวิชา 01204223 Practicum for Computer Engineering ภาคปลาย ปีการศึกษา 2564 หมู่ 11,12

## สมาชิกผู้จัดทำ:  
> :shipit:นิสิตภาควิชาวิศวกรรมคอมพิวเตอร์ คณะวิศวกรรมศาสตร์ มหาวิทยาลัยเกษตรศาสตร์ วิทยาเขตบางเขน:shipit:  

6310500261 นายชยพล สาสนรักกิจ<br>
6310500295 นายทิวัตถ์ ทรัพย์รัตนกุล<br>
6310503308 นายณัฐดนัย เติมบุญผาติ<br>
6310503499 นายภราดร วัชรเสมากุล<br>

## Table of contents    
  - [รายละเอียดไฟล์ Source Code](#รายละเอียดไฟล์-source-code)
  - [รายการไลบรารีและเฟรมเวิร์คที่ใช้](#รายการไลบรารีและเฟรมเวิร์คที่ใช้)
  - [รายการอุปกรณ์ฮาร์ดแวร์ที่ใช้](#รายการอุปกรณ์ฮาร์ดแวร์ที่ใช้)

## รายละเอียดโฟลเดอร์
### audio   
```
โฟลเดอร์สำหรับเก็บไฟล์เสียงในเกมต่างๆ
│   BGM InGame.mp3        : เสียงเกมตอนกำลังเล่น
│   BGM Menu.mp3          : เสียงเกมตอนอยู่หน้าเมนู
```

### font
```
โฟลเดอร์สำหรับเก็บฟอนต์ต่างๆในเกม
|   04B_30__.TTF          : ฟอนต์ในเกม
```

### only_keyboard 
```
โฟลเดอร์สำหรับเก็บข้อมูลในการเล่นเกมโดยรับinputจากแป้นพิมพ์
│   Tetris.py             : โปรแกรมสำหรับการเก็บข้อมูลและอัลกรอลิทึมในเกมส์   
│   menu.py               : โปรแกรม GUI สำหรับการแสดงผล หน้าตัวเลือกในการเล่นเกม (รันเกมจากไฟล์นี้)
|   multi.py              : โปรแกรม GUI สำหรับการแสดงผล การเล่นเกมแบบ 2 คน
|   single.py             : โปรแกรม GUI สำหรับการแสดงผล การเล่นเกมแบบ 1 คน
|   How_to_play.py        : โปรแกรม GUI สำหรับการแสดงผล วิธีการเล่นเกมส์
```

### pic
```
|  BG_HowTP.jpeg          : รูปพื้นหลังใน How to play
|  BG_Menu.jpg            : รูปภาพพื้นหลังหน้าmenu
|  board.jpeg             : รูปบอร์ดที่ใช้
|  menu_button.png        : รูปพื้นหล้งปุ่มกด
```

### tetris_upgrade 
```
โฟลเดอร์สำหรับเก็บข้อมูลในการเล่นเกมโดยรับ input จาก MCU
│   Tetris.py             : โปรแกรมสำหรับการเก็บข้อมูลและอัลกรอลิทึมในเกม  
│   menu.py               : โปรแกรม GUI สำหรับการแสดงผล หน้าตัวเลือกในการเล่นเกม 
|   multi.py              : โปรแกรม GUI สำหรับการแสดงผล การเล่นเกมแบบ 2 คน
|   single.py             : โปรแกรม GUI สำหรับการแสดงผล การเล่นเกมแบบ 1 คน
|   How_to_play.py        : โปรแกรม GUI สำหรับการแสดงผล วิธีการเล่นเกมส์
|   practicum.py          : ส่ง request ให้ mcu ผ่าน pyusb
```

### firmware
```
โฟลเดอร์สำหรับเก็บข้อมูลเฟิร์มแวร์
|   Makefile              : makefile
|   main.c                : รับ request จาก Host
|   peri.c                : ไว้initial port และ analog read
|   peri.h                : เป็น header ของ peri.c
```

### Others  
```
README.md : ไฟล์ระบุชื่อกลุ่ม ชื่อโครงงาน รายชื่อผู้จัดทำ รายละเอียดไฟล์ รายการไลบรารี/
```

## รายการไลบรารีและเฟรมเวิร์คที่ใช้
### Hardware 
`usbconfig.h`

### Frontend 
`-`

### Backend 
`pygame` `random` `State` 

## รายการอุปกรณ์ฮาร์ดแวร์ที่ใช้
<ul>
  <li>Raspberry PI 1 ตัว</li>
  <li>Board NodeMCU - ATmega328p (Practicum Board v3.2 CPE. KU 2020-11) 2 ตัว</li>
  <li>Peripheral board (PRACTICUM PROTOBOARD CPE. KU) 2 บอร์ด</li>
  <li>สายแพร์ 2 เส้น</li>
  <li>Tag Switch(สวิตซ์กดติดปล่อยดับ) ขนาด 6 x 6 mm 8 ตัว</li>
  <li>เซนเซอร์แสง(LDR) 2 ตัว</li>
  <li>ตัวต้านทาน 10K 2 ตัว</li>
  </ul>
